require 'yaml'

#
# Sets Application Configurations
#
class ApplicationConfig
  @@client_id = ''
  @@client_secret = ''
  @@base_url = ''
  @@config = {}

  #
  # Sets Application Configuration
  #
  # @param [String] client_id
  # @param [String] client_secret
  # @param [String] base_url
  #
  def self.set_config(client_id, client_secret, base_url)
    @@client_id = client_id
    @@client_secret = client_secret
    @@base_url = base_url
    @@config = YAML.load_file(File.join(File.dirname(File.dirname(__FILE__)), 'config.yml'))
  end

  #
  # Return Client Id
  #
  # @return [String]
  #
  def self.client_id
    @@client_id
  end

  #
  # Returns Client Secret
  #
  # @return [String]
  #
  def self.client_secret
    @@client_secret
  end

  #
  # Returns Base Url
  #
  # @return [String]
  #
  def self.base_url
    @@base_url
  end

  #
  # Creates complete url by key
  #
  # @return [String]
  #
  def self.get_url(key)
    url = @@base_url + @@config[key]
    url
  end
end
