require 'json'

#
# Widget model conatining widget craeate and update attributes
#
class Widget
  attr_accessor :name
  attr_accessor :description
  attr_accessor :kind

  #
  #  Inialise the widget model
  #
  # @param [String] name Name of widget
  # @param [String] description
  # @param [String] kind Kind of widget - hidden/visible
  #
  def initialize(name: nil, description: nil, kind: nil)
    self.name = name
    self.description = description
    self.kind = kind
  end

  #
  # Converts Widget object to Hash and deletes null value fields
  #
  # @param [Refrence] options
  #
  # @return [Hash] Hash of widget object
  #
  def as_json(options = {})
    hash_data = {
      self.class.name.downcase => {
        name: @name,
        description: @description,
        kind: @kind
      }
    }

    hash_data.each { |k, v| v.delete_if { |k, v| v.nil? || v.empty? } }
    hash_data
  end

  #
  # Gets Json represenatation of widget object
  #
  # @param [Object] widget Widget object
  #
  # @return [Json] Json represenatation of widget object
  #
  def self.get_payload(widget)
    widget.as_json.to_json
  end
end
